(function(window){
	var callbackHandler = function(name){
		this.fName = name;
		this.channels = {};
	};
	callbackHandler.prototype = {
		constructor : callbackHandler,
		fName : null,
		callback : function(data){
			//TODO 根据订阅的渠道分别通知指定的人
			let self = this;
			for(let k in self.channels){
				//给自身发
				if("iframe_container" === k){
					window.postMessage({
						name : self.fName,
						data : data,
						_isSelf : true
					},"*");
				}else{
					self.channels[k] && window.frames[k] && window.frames[k].postMessage({
						name : self.fName,
						data : data
					},"*");
				}

			}
		}
	};

	var bridgeManager = {
		__cbs__ : {},

		channelConf : {
			"cocos" : "cocos_iframe",
			"pet" : "pet_iframe",
			"ppt" : "ppt_iframe",
			"iframe" : "iframe_container"
		},

		_getHandler : function(name){
			return this.__cbs__[name];
		},

		_addHandler : function(name){
			!this.__cbs__[name] && (this.__cbs__[name] = new callbackHandler(name));
			return this.__cbs__[name];
		},

		_clearHandler : function(name,channel){
			let _h = this._getHandler(name);
			//没有订阅的渠道 则整个销毁
			if(Object.keys(_h.channels).length < 1){
				winBridge.removeMethod(name,_h.callback);
				delete this.__cbs__[name];
			}
		},

		_addChannel : function(name,channel){
			let _h = this._addHandler(name);
			//该name对应的事件有人监听则不需要再添加
			if(Object.keys(_h.channels).length > 0){
        _h.channels[channel] = true;
        return false;
			}else{
        _h.channels[channel] = true;
        return _h;
			}
		},

		getChannelBySource : function(source){
			return this.channelConf[source];
		},

		//订阅消息
		subscribe : function(name,channel){
			let handler = this._addChannel(name,channel);
      handler && winBridge.addMethod(name,handler.callback.bind(handler));
		},

		//发布消息 TODO 是否支持同级iframe通信
		publish : function(name,data){
			if(data){
				winBridge.invokeMethod(name,data);
			}else{
				winBridge.invokeMethod(name);
			}
		},

		//取消订阅
		unsubscribe : function(name,channel){
			let _h = this._getHandler(name);
			if(_h){
				channel = channel || "";
				delete _h.channels[channel];
				this._clearHandler(name,channel);
			}
		},
		onmessage : function(data){
			let type = data.type;
			let channel = this.getChannelBySource(data.source);
			console.info("%cPOSTMRSSAGE--> Has a message %c[%s] from [%s] !","color:blue;font:24px","color:red",data.name,channel,data);
			switch(type){
				case "subscribe" :
					this.subscribe(data.name,channel);
					break;
				case "publish" :
					this.publish(data.name,data.data);
					break;
				case "unsubscribe" :
					this.unsubscribe(data.name,channel);
					break;
			};
		}
	};


/*---------------取代bridge 对外暴露于 bridge一样的三个方法，由于自身即作为消息收发中心又作为渠道需要添加监听 都在onmessage中--------------------*/
var messageBridge = {
    _callbacks : {},
   	options : {
      type : "",
      data : "",
      source : "iframe"
   	},
  //发送消息
  invokeMethod(name, args){
      let options = Object.assign({},this.options,{
          type : "publish",
          name : name,
          data : args
      });
      window.top.postMessage(options,"*");
  },
  addMethod(name, method) {
    let options = Object.assign({},this.options,{
      type : "subscribe",
      name : name
    });
    if(this._callbacks[name]){
      this._callbacks[name].push(method);
		}else{
      this._callbacks[name] = [];
      this._callbacks[name].push(method);
      window.top.postMessage(options,"*");
		}
  },
  removeMethod(name,method){
    if(!this._callbacks[name])return;
    let options = Object.assign({},this.options,{
      type : "unsubscribe",
      name : name
    });
    //找出注入的方法并从数组中删除之
    let len = this._callbacks[name].length;
    for(let i = 0; i < len;i++){
    	if(this._callbacks[name][i] === method){
        this._callbacks[name].splice(i,1);
        len --;
			}
		}
		//已经没有注入的方法则注销监听
		if(len < 1){
      delete this._callbacks[name];
      window.top.postMessage(options,"*");
		}
  },
  //通过名称直接调用方法
  callFunctionByName : function(name,args){
  	if(!this._callbacks[name])return;
    this._callbacks[name].forEach(fn=>fn(args));
  }
};

window.onmessage = function(e){
	let data = e.data;
	if(data._isSelf){
		messageBridge.callFunctionByName(data.name,data.data);
	}else{
		bridgeManager.onmessage(data);
	}
};

window.messageBridge = messageBridge;

})(window);
