/*
 * @Author: hexiaokang
 * @Date:   2019-03-08
 * @comment: 大浣熊画笔插件
 */
window.onload = function () {
  //创建svg元素
  var svgElement = document.createElementNS('http://www.w3.org/2000/svg', 'svg')
  var svgAttribbues = {
    width: '100%',
    height: '100%',
    version: '1.1',
    id: 'svgPaintContainer',
    xmlns: 'http://www.w3.org/2000/svg',
    style: 'position:fixed;left:0px;top:0px;background:rgba(1,1,1,0);'
  }
  for (let key in svgAttribbues) {
    svgElement.setAttribute(key, svgAttribbues[key])
  }
  var isOpenPaint = false //是否开启画笔绘制功能
  var openAxisSave = false //控制是否记录鼠标坐标点
  var pointAxisList = [] //连续两点坐标
  var svgPolylineLineList = [] //Polyline线段集合
  // 屏幕获取端那边初始化影响到我们获取webview的宽度和高度，所以要在鼠标移动的时候在取
  var screenWidth = null
  var screenHeight = null
  var globalCurrentPage = null
  document.getElementsByTagName('body')[0].appendChild(svgElement)

  //每次页面重新载入清楚globalSvgPolylineLine
  window.localStorage.removeItem("globalSvgPolylineLine")

  var globalSvgPolylineLineList = [] // 用于翻页一次性发给win端数据
  var curPage = null // 当前页面
  var lineColor = 'red', // 线的颜色
      lineType = 1,  // 线的类型
      lineSize = 2;  // 线的宽度
  //绑定相应事件
  svgElement.onmousedown = function () {
    openAxisSave = true
    svgPolylineLineList = []
    pointAxisList = []
  }
  svgElement.onmouseup = function () {
    openAxisSave = false
    if(!isOpenPaint){return}
    window.localStorage.removeItem('secondPoint')
    var polylines = null;
    //线段数不足10条时发送
    if(svgPolylineLineList.length < 10){
      polylines = svgPolylineLineList
    }
    //线段总数取余超过0时发送
    if(svgPolylineLineList.length % 10 > 0){
      var leave = svgPolylineLineList.length % 10
      polylines = svgPolylineLineList.slice(-leave)
    }

    var data = {
      dataType: 2,
      content: {
        points: polylines,
        lineColor: 'red',
        lineType: 1,
        lineSize: 2
      }
    }
    messageBridge.invokeMethod('onJsCommand',{
      0: JSON.stringify({
        name: "paintline",
        data: data
      }) 
    })
  }
  svgElement.onmousemove = function (event) {
    if(!isOpenPaint){return}
    if (openAxisSave) {
      console.log('画笔')
      console.log('x', event.clientX)
      console.log('y', event.clientY)
      console.log('画笔')
      var clientRect = document.body.getBoundingClientRect()
      screenWidth = clientRect.width || 1334
      screenHeight = clientRect.height || 560
      pointAxisList.push((event.clientX/screenWidth).toFixed(4) + ',' + (event.clientY/screenHeight).toFixed(4))
      if (pointAxisList.length === 2) {
        let twoPoints = pointAxisList.join(' ')
        svgPolylineLineList.push({
          points: twoPoints
        })

        globalSvgPolylineLineList.push({
          points: twoPoints
        })
        //向win端传输数据时，每隔10条线段发送一次
        if(svgPolylineLineList.length%10 == 0){
          // console.info('svgPolylineLineList.slice(-10):',svgPolylineLineList.slice(-10))
          var data = {
            dataType: 2,
            content: {
              points: svgPolylineLineList.slice(-10),
              lineColor: 'red',
              lineType: 1,
              lineSize: 2
            }
          }
          messageBridge.invokeMethod('onJsCommand',{
            0: JSON.stringify({
              name: "paintline",
              data: data
            })
          })
        }
        let firstPoint = pointAxisList[0]
        let secondPoint = pointAxisList[1]
        let secondPointCache = window.localStorage.getItem('secondPoint')
        if (secondPointCache) {
          svgPolylineLineList.push({
            points: `${secondPointCache} ${firstPoint}`
          })

          globalSvgPolylineLineList.push({
            points: `${secondPointCache} ${firstPoint}`
          })
        }
        window.localStorage.setItem('secondPoint', secondPoint)
        pointAxisList = []
      }
      paintLine(svgPolylineLineList)
    }
  }

  //生成绘制polyline线段
  function paintLine(_list){
    console.log('_list')
    console.log(_list)
    console.log('_list')
    _list.map(item => {
      var polylineElementItem = document.createElementNS('http://www.w3.org/2000/svg', 'polyline')
      var point1s = item.points.split(' ')[0].split(',')
      var point2s = item.points.split(' ')[1].split(',')
      // 重新获取
      var clientRect = document.body.getBoundingClientRect()
      screenWidth = clientRect.width || 1334
      screenHeight = clientRect.height || 560
      point1s[0] = parseFloat(point1s[0])*screenWidth
      point1s[1] = parseFloat(point1s[1])*screenHeight
      point2s[0] = parseFloat(point2s[0])*screenWidth
      point2s[1] = parseFloat(point2s[1])*screenHeight
      polylineElementItem.setAttribute('points', point1s.join()+' '+point2s.join())
      polylineElementItem.setAttribute('style', 'fill:none;stroke:red;stroke-width:2')
      var hasCurrentpolyine = false
      var svgTag = document.getElementsByTagName('svg')[0]
      for(var index=0;index<svgTag.children.length;index++){
        var p1 = svgTag.children[index].getAttribute('points')
        var p2 = polylineElementItem.getAttribute('points')
        if(p1 == p2){
          hasCurrentpolyine = true
        }
      }
      if(!hasCurrentpolyine){
        document.getElementsByTagName('svg')[0].appendChild(polylineElementItem)
      }
    })
  }

  messageBridge.addMethod('jsCommand', function(str){
    console.log('返回数据', str)
    var tempData = JSON.parse(str.data);
    if (tempData.data.dataType == 2) {

      // 由于移动端所以要在这个地方记录数据
      if (tempData.data.content &&  tempData.data.content.points && tempData.data.content.points.length > 0){
        
        var oldGlobalSvgPolylineLine = window.localStorage.getItem("globalSvgPolylineLine") || null
        if (oldGlobalSvgPolylineLine){
          var storageSvgPolylineLine =  JSON.parse(oldGlobalSvgPolylineLine) || []
          if (storageSvgPolylineLine.content && storageSvgPolylineLine.content.points){
            for(var i = 0; i < tempData.data.content.points.length; i++){
              storageSvgPolylineLine.content.points.push(tempData.data.content.points[i])
            }
          }

          window.localStorage.setItem("globalSvgPolylineLine", JSON.stringify({
              content: {
                points: storageSvgPolylineLine.content.points
              }
            })
          )
        }else {
          window.localStorage.setItem("globalSvgPolylineLine", JSON.stringify({
              content: {
                points: tempData.data.content.points
              }
            })
          )
        }
        
      }

      paintLine(tempData.data.content.points)
      
    }else if (tempData.data.dataType == 0) {
      document.getElementById('svgPaintContainer').innerHTML = ''
    }    
  })

  //注册获取操作指令接口
  winBridge.addMethod("jsTeachingCmd", function(_obj){
    if (_obj.cmdType == 2){
      isOpenPaint = true
      svgElement.style.pointerEvents = "auto";
    }else{
      isOpenPaint = false
    }
    if (_obj.cmdType == 0) {
      svgElement.style.pointerEvents = "none";
    }
    if(_obj.cmdType == 4){
      document.getElementById('svgPaintContainer').innerHTML = ''
      messageBridge.invokeMethod('onJsCommand',{
        0: JSON.stringify({
          name: "paintline",
          data: {
            dataType: 2,
            content: {}
          }
        })
      })
  
      winBridge.invokeMethod('onClearHandWriting', {
        0: globalCurrentPage
      })
      window.localStorage.removeItem("globalSvgPolylineLine")
      // 删除text
      delTextInput()
    }
  });

  messageBridge.addMethod("jsH5NextPageHX", function(_obj){
    console.log(_obj)
    // 取数据
    var pointDatas = _obj
    curPage = pointDatas.data
    var oldGlobalSvgPolylineLine = window.localStorage.getItem("globalSvgPolylineLine") || null
    if (oldGlobalSvgPolylineLine){
      var storageSvgPolylineLine =  JSON.parse(oldGlobalSvgPolylineLine) || []
      if (storageSvgPolylineLine.content && storageSvgPolylineLine.content.points){
        var newSvgPolylineLineList = storageSvgPolylineLine.content.points.concat(globalSvgPolylineLineList)
      }
    }else{
      var newSvgPolylineLineList = globalSvgPolylineLineList
    }
    var _content = {
      points: newSvgPolylineLineList,
      lineColor: lineColor,
      lineType: lineType,
      lineSize: lineSize
    }

    
    // 翻页提交数据
    winBridge.invokeMethod('onSaveHandWriting', {
      0: curPage, 
      1:JSON.stringify({
        dataType: 2,
        content: _content
      })
    })
    // 清理旧数据
    document.getElementById('svgPaintContainer').innerHTML = ''
    globalSvgPolylineLineList = []
    window.localStorage.removeItem("globalSvgPolylineLine")
    // 删除text
    delTextInput()

    globalCurrentPage = pointDatas.data + 1
    winBridge.invokeMethod('onGetHandWriting', {
      0: pointDatas.data + 1
    })  // 告诉端翻页成功

    // 拉新页面数据
    winBridge.addMethod('jsRenderHandWriting', function(_obj){
      if (_obj.teachingData) {
        var newPointDatas = JSON.parse(_obj.teachingData)
        paintLine(newPointDatas.content.points)
        window.localStorage.setItem("globalSvgPolylineLine", _obj.teachingData)
      }
    })
    console.log('next', _obj)
  });


  messageBridge.addMethod("jsH5PrevPageHX", function(_obj){
    console.log(_obj)
    // 取数据
    var pointDatas = _obj
    curPage = pointDatas.data
    var oldGlobalSvgPolylineLine = window.localStorage.getItem("globalSvgPolylineLine") || null
    if (oldGlobalSvgPolylineLine){
      var storageSvgPolylineLine =  JSON.parse(oldGlobalSvgPolylineLine) || []
      if (storageSvgPolylineLine.content && storageSvgPolylineLine.content.points){
        var newSvgPolylineLineList = storageSvgPolylineLine.content.points.concat(globalSvgPolylineLineList)
      }
    }else{
     var newSvgPolylineLineList = globalSvgPolylineLineList
    }
    var _content = {
      points: newSvgPolylineLineList,
      lineColor: lineColor,
      lineType: lineType,
      lineSize: lineSize
    }
    // 翻页提交数据
    winBridge.invokeMethod('onSaveHandWriting', {
      0: curPage, 
      1:JSON.stringify({
        dataType: 2,
        content: _content
      })
    })
    // 清理旧数据
    document.getElementById('svgPaintContainer').innerHTML = ''
    globalSvgPolylineLineList = []
    window.localStorage.removeItem("globalSvgPolylineLine")
    // 删除text
    delTextInput()

    globalCurrentPage = pointDatas.data - 1
    winBridge.invokeMethod('onGetHandWriting', {
      0: pointDatas.data - 1
    })  // 告诉端翻页成功
    // 拉新页面数据
    winBridge.addMethod('jsRenderHandWriting', function(_obj){
      if (_obj.teachingData) {
        var newPointDatas = JSON.parse(_obj.teachingData)
        console.log('newPointDatas')
        console.log(newPointDatas)
        console.log('newPointDatas')
        paintLine(newPointDatas.content.points)
        window.localStorage.setItem("globalSvgPolylineLine", _obj.teachingData)
      }
    })
    console.log('prev', _obj)
  });

}


function delTextInput() {
  var nodeArr = document.querySelectorAll('.contenteditable-div');
  if (!nodeArr.length) {
    return false
  }
  for(var i=0;i<nodeArr.length;i++){
  var chnode=nodeArr[i];
  chnode && document.body.removeChild(chnode);  
  }
}